<?php
/******************************************
* File      :   include.logs.php
* Project   :   Contenido
* Descr     :   Displays log entries
*
* Author    :   Timo A. Hummel
* Created   :   09.05.2003
* Modified  :   09.05.2003
*
*  four for business AG
*****************************************/

cInclude("classes", "class.user.php");
cInclude("classes", "class.action.php");
cInclude("classes", "class.structure.php");
cInclude("classes", "class.art.php");

$clientclass = new Client;

$db2 = new DB_Contenido;

if(!$perm->have_perm_area_action($area))
{
  $notification->displayNotification("error", i18n("Permission denied"));
} else {

    $tpl->reset();


    $form = '<form name="log_select" method="post" action="'.$sess->url("main.php?").'">
                 '.$sess->hidden_session().'
                 <input type="hidden" name="area" value="'.$area.'">
                 <input type="hidden" name="action" value="log_show">
                 <input type="hidden" name="frame" value="'.$frame.'">';


    $tpl->set('s', 'FORM', $form);
    $tpl->set('s', 'BORDERCOLOR', $cfg["color"]["table_border"]);
    $tpl->set('s', 'SELECTBGCOLOR', $cfg["color"]["table_dark"]);
    $tpl->set('s', 'SELECTBBGCOLOR', $cfg["color"]["table_light"]);
    $tpl->set('s', 'HEADERBGCOLOR', $cfg["color"]["table_header"]);
    $tpl->set('s', 'RHEADERBGCOLOR', $cfg["color"]["table_header"]);
    $tpl->set('s', 'SUBMITTEXT', i18n("Submit query"));
    $tpl->set('s', 'CANCELLINK', $sess->url("main.php?area=$area&frame=4"));


    $userclass = new Users();
    $structureclass = new Structure();
    $artclass = new Art();
    $actionclass = new Action();

    $clients = $clientclass->getAccessibleClients();
    $users = $userclass->getAccessibleUsers(split(',',$auth->auth["perm"]));
    $userselect = "<option value=\"%\">".i18n("All users")."</option>";
    $actions = $actionclass->getAvailableActions();
    $actionselect = "<option value=\"%\">".i18n("All actions")."</option>";
   	$clientList = $clientclass->getAccessibleClients();

   	foreach ($clientList as $key=>$value) {
        if (strcmp($idqclient,$key) == 0) {
            $selected = "SELECTED";
        } else {
            $selected = "";
        }

        $clientselect .= "<option value=\"".$key."\" ".$selected.">".$value["name"]."</option>";
    }

    foreach ($users as $key=>$value) {
        if (strcmp($idquser,$key) == 0) {
            $selected = "SELECTED";
        } else {
            $selected = "";
        }

        $userselect .= "<option value=\"".$key."\" ".$selected.">".$value["username"]." (".$value["realname"].")</option>";
    }

    foreach ($actions as $key=>$value) {
        if (strcmp($idqaction,$key) == 0) {
            $selected = "SELECTED";
        } else {
            $selected = "";
        }

        $areaname = $classarea->getAreaName($actionclass->getAreaForAction($value["name"]));
        $actionDescription =  $lngAct[$areaname][$value["name"]];

        if ($actionDescription == "")
        {
            $actionDescription = $value["name"];
        }

        $actionselect .= "<option value=\"".$key."\" ".$selected.">".$value["name"]." (".$actionDescription.")"."</option>";
    }

    for ($i = 1; $i < 32; $i ++) {
        if (date("j") == $i) {
            $selected = "SELECTED";
        } else {
            $selected = "";
        }
        $dayselect .= '<option value="'.$i.'" '.$selected.'>'.$i.'</option>';
    }

    for ($i = 1; $i < 13; $i ++) {
        if (date("n") == $i) {
            $selected = "SELECTED";
        } else {
            $selected = "";
        }
        $monthselect .= '<option value="'.$i.'" '.$selected.'>'.$i.'</option>';
    }

    for ($i = 2000; $i < 2010; $i ++) {
        if (date("Y") == $i) {
            $selected = "SELECTED";
        } else {
            $selected = "";
        }
        $yearselect .= '<option value="'.$i.'" '.$selected.'>'.$i.'</option>';
    }


    $limitselect  = '<option value="0">'.i18n("Unlimited").'</option>';
    $limitselect .= '<option value="10" SELECTED>10 '.i18n("Entries").'</option>';
    $limitselect .= '<option value="20">20 '.i18n("Entries").'</option>';
    $limitselect .= '<option value="30">30 '.i18n("Entries").'</option>';
    $limitselect .= '<option value="50">50 '.i18n("Entries").'</option>';
    $limitselect .= '<option value="100">100 '.i18n("Entries").'</option>';

    $tpl->set('s', 'USERS', $userselect);
    $tpl->set('s', 'CLIENTS', $clientselect);
    $tpl->set('s', 'ACTION', $actionselect);
    $tpl->set('s', 'FROMDAY', $dayselect);
    $tpl->set('s', 'FROMMONTH', $monthselect);
    $tpl->set('s', 'FROMYEAR', $yearselect);
    $tpl->set('s', 'TODAY', $dayselect);
    $tpl->set('s', 'TOMONTH', $monthselect);
    $tpl->set('s', 'TOYEAR', $yearselect);
    $tpl->set('s', 'LIMIT', $limitselect);

    $fromdate = "$fromyear-$frommonth-$fromday 00:00:00";
    $todate = "$toyear-$tomonth-$today 23:59:00";

    if ($limit == 0)
    {
        $limitsql = "";
    } else {
        $limitsql = "LIMIT ".$limit;
    }

	if ($idquser == "%")
	{
		$users = $userclass->getAccessibleUsers(split(',',$auth->auth["perm"]));

		foreach ($users as $key=>$value) {
			$userarray[] = $key;
		}

      	$uservalues = implode('", "',$userarray);
		$userquery = 'IN ("'.$uservalues.'")';
	} else {
		$userquery = "LIKE '".$idquser."'";
	}

$sql = 'SELECT
                idlog,
                user_id,
                idaction,
		      idlang,
		      idclient,
                idcatart,
                logtimestamp
            FROM
              '. $cfg["tab"]["actionlog"] . '
            WHERE
                user_id '.$userquery.' AND
                idaction LIKE "'.$idqaction.'" AND
                logtimestamp > "'.$fromdate.'" AND
                logtimestamp < "'.$todate.'" AND
            idclient LIKE "'.$idqclient.'"
                ORDER BY logtimestamp DESC '
                . $limitsql;

    $db->query($sql);

    if ($db->affected_rows() == 0)
    {
        $noresults = '<tr class="text_medium" style="background-color: '.$bgcolor.';" >'.
                     '<td valign="top" colspan="6" style="border: 0px; border-top:1px; border-right:1px;border-color: '.$cfg["color"]["table_border"].'; border-style: solid;">'.i18n("No results").'</td></tr>';

    } else {
        $noresults = "";
    }

        $tpl->set('s', 'NORESULTS', $noresults);


    while ($db->next_record())
    {

        $darkrow = !$darkrow;

        if ($darkrow)
        {
            $bgcolor = $cfg["color"]["table_dark"];
        } else {
            $bgcolor = $cfg["color"]["table_light"];
        }

		$structureName = $structureclass->getStructureName($structureclass->getStructureIDForCatArt($db->f("idcatart")),$db->f("idlang"));
		$artName = $artclass->getArtName($artclass->getArtIDForCatArt($db->f("idcatart")),$db->f("idlang"));

        if ($structureName == "") { $structureName = "-"; }
        if ($artName == "") { $artName = "-"; }

		$tpl->set('d', 'BORDERCOLOR', $cfg["color"]["table_border"]);
        $tpl->set('d', 'RBGCOLOR', $bgcolor);
        $tpl->set('d', 'RCLIENT', $clientList[$db->f("idclient")]["name"]);
        $tpl->set('d', 'RDATETIME', $db->f("logtimestamp"));
        $tpl->set('d', 'RUSER' , $users[$db->f("user_id")]["username"]);
        $areaname = $classarea->getAreaName($actionclass->getAreaForAction($db->f("idaction")));
        $actionDescription =  $lngAct[$areaname][$actionclass->getActionName($db->f("idaction"))];
        if ($actionDescription == "")
        {
            $actionDescription = $actionclass->getActionName($db->f("idaction"));
        }
        $tpl->set('d', 'RACTION', $actionDescription );
        $tpl->set('d', 'RSTR', $structureName);
        $tpl->set('d', 'RPAGE', $artName);

        $tpl->next();

    }


    # Generate template
    $tpl->generate($cfg['path']['templates'] . $cfg['templates']['log_main']);
}

?>
